package ai.pai.lensman.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class EncryptUtils {

    public static void xorFile(String filename, String dest, byte[] password) throws IOException {
        File destFile = new File(dest);
        if(destFile.exists()){
            destFile.delete();
        }
        destFile.createNewFile();
        FileInputStream is = new FileInputStream(filename);
        FileOutputStream os = new FileOutputStream(dest);

        byte[] data = new byte[1024 * 4]; //4 KB buffer
        int read = is.read(data), index = 0;
        while (read != -1) {
            for (int k = 0; k < read; k++) {
                data[k] ^= password[index % password.length];
                index++;
            }
            os.write(data, 0, read);
            read = is.read(data);
        }

        os.flush();
        os.close();
        is.close();
    }

    public static void xorFile(String filename, String dest, byte[] password, long encryptByteCount) throws IOException {
        FileInputStream is = new FileInputStream(filename);
        FileOutputStream os = new FileOutputStream(dest);

        byte[] data = new byte[1024 * 4]; //4 KB buffer
        int read = is.read(data), index = 0, encryptCnt = 0;
        while (read != -1) {
            for (int k = 0; k < read; k++) {
                if (encryptCnt < encryptByteCount) {
                    data[k] ^= password[index % password.length];
                    index++;
                    encryptCnt++;
                }
            }
            os.write(data, 0, read);
            read = is.read(data);
        }

        os.flush();
        os.close();
        is.close();
    }

}
